class Editor.EditorModule.DockModule.ScenarioBay.Element extends Pettanr.View
  tagName: 'li'
  className: 't-label'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @element = options.element
  
  render: () ->
    this.$el.html('')
    this.$el.attr('data-t', @t())
    @label = new Editor.EditorModule.DockModule.ScenarioBay.ElementLabel({
      parent: this, 
    })
    @body = new Editor.EditorModule.DockModule.ScenarioBay.ElementBody({
      parent: this, 
    })
    this.$el.append(@label.render().$el)
    this.$el.append(@body.render().$el)
    @rb()
    this
  
  refresh: () ->
    @body.form.refresh()
  
  t: () ->
    @element.get('t')
  
  dom_id: () ->
    super() + '-' + @element.get('id')  # use tab index
  
class Editor.EditorModule.DockModule.ScenarioBay.ElementLabel extends Pettanr.View
  className: 'scenario-label'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
  
  render: () ->
    this.$el.append(@element().element_face().render().el)
    _this = this
    this.$el.mouseover -> 
      _this.element().trigger('active')
    this.$el.mouseout -> 
      _this.element().trigger('inactive')
    this
  
  element: () ->
    @parent.element
  
  elements: () ->
    @parent.parent
  
  bay: () ->
    @elements().parent
  
  dock: () ->
    @bay().dock()
  
class Editor.EditorModule.DockModule.ScenarioBay.ElementBody extends Pettanr.View
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @form = Locmare.Form.factory({
      form_name: @element().item_name(), 
      use_name: 'scenario' 
      item: @element(), 
      element_form: true, 
      submit: null, 
    })
  
  render: () ->
    this.$el.html(@form.render().el)
    this
  
  element: () ->
    @parent.element
  
  elements: () ->
    @parent.parent
  
  bay: () ->
    @elements().parent
  
  dock: () ->
    @bay().dock()
  
  mounted: () ->
    true
  
  element: () ->
    @parent.element
  
