class Locmare.FormModule.FieldModule.HelperModule.Color extends Locmare.FormModule.FieldModule.HelperModule.Base
  tagName: 'div'
  className: 'code-wrap'
  
  # wrapper
  initialize: (options) ->
    super(options)
    this.$el.addClass(@helper_manifest.dom_class)
    @picker = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Picker({field: @field, helper: this})
    @swatch = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Swatch({field: @field, helper: this})
    @status = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Status({field: @field, helper: this})
  
  render: () ->
    @attr = {
      style: 'display: block'
    }
    this.$el.attr(@attr)
    this.$el.html('')
    this.$el.append(@picker.render().el)
    this.$el.append(@swatch.render().el)
    this.$el.append(@status.render().el)
    @rb()
    this
  
  refresh: () ->
    @picker.refresh()
    @swatch.refresh()
    @status.refresh()
  
  h: () -> 
    c = @field.value()
    h = "000000" + c.toString(16)
    h.substring(h.length - 6)
  
  slider_change: () -> 
    red = @picker.red.$el.slider('value')
    green = @picker.green.$el.slider('value')
    blue = @picker.blue.$el.slider('value')
    code = (red << 16) + (green << 8) + (blue)
    @field.tag.$el.val(code)
    @field.trigger('change')
    @swatch.refresh()
    @status.refresh()
  
class Locmare.FormModule.FieldModule.HelperModule.ColorModule
class Locmare.FormModule.FieldModule.HelperModule.ColorModule.Slider extends Tag.Div
  className: 'colorpicker'
  events: {
    slidechange: 'slider_change'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
    @shift = options.shift
    @name = options.name
    super({})
    this.$el.addClass('colorpicker-' + @name)
  
  slider_change: (trace) -> 
    @helper.slider_change()
  
  volume: () ->
    (@field.value() >> @shift) & 0xFF
  
class Locmare.FormModule.FieldModule.HelperModule.ColorModule.Picker extends Pettanr.View
  tagName: 'div'
  className: 'colorpickers'
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
    @red = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Slider({
      field: @field, helper: @helper, shift: 16, name: 'red'
    })
    @green = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Slider({
      field: @field, helper: @helper, shift: 8, name: 'green'
    })
    @blue = new Locmare.FormModule.FieldModule.HelperModule.ColorModule.Slider({
      field: @field, helper: @helper, shift: 0, name: 'blue'
    })
    r = (@field.value() >> 16) & 0xFF
    g = (@field.value() >> 8) & 0xFF
    b = @field.value() & 0xFF
    @red.$el.slider {
      orientation: 'horizontal',
      range: 'min',
      max: 255,
      value: r 
    }
    @green.$el.slider {
      orientation: 'horizontal',
      range: 'min',
      max: 255,
      value: g 
    }
    @blue.$el.slider {
      orientation: 'horizontal',
      range: 'min',
      max: 255,
      value: b 
    }
  
  render: () ->
    @attr = {
      style: 'float: left;'
    }
    this.$el.attr(@attr)
    this.$el.html('')
    this.$el.append(@red.render().el)
    this.$el.append(@green.render().el)
    this.$el.append(@blue.render().el)
    this
  
  refresh: () -> 
    null
  
class Locmare.FormModule.FieldModule.HelperModule.ColorModule.Swatch extends Pettanr.View
  tagName: 'div'
  className: 'code_swatch'
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
    this.$el.addClass('ui-widget-content')
    this.$el.addClass('ui-corner-all')
  
  render: () ->
    @attr = {
      style: 'float: left;'
    }
    this.$el.attr(@attr)
    this.$el.html('')
    @refresh()
    this
  
  refresh: () -> 
    this.$el.css('background-color', '#' + @helper.h())
  
class Locmare.FormModule.FieldModule.HelperModule.ColorModule.Status extends Pettanr.View
  tagName: 'div'
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
    @hex = new Tag.Div({})
    @rgb = new Tag.Div({})
  
  render: () ->
    @attr = {
      style: 'float: left;'
    }
    this.$el.attr(@attr)
    
    this.$el.html('')
    this.$el.append(@hex.render().el)
    this.$el.append(@rgb.render().el)
    @refresh()
    this
  
  refresh: () -> 
    @hex.$el.html('HEX: #' + @helper.h())
    @rgb.$el.html('RGB: (' + @r()  + ',' + @g()  + ',' + @b()  + ')' )
  
  r: () -> 
    @helper.picker.red.volume().toString()
  
  g: () -> 
    @helper.picker.green.volume().toString()
  
  b: () -> 
    @helper.picker.blue.volume().toString()
  
