class Locmare.ProfilerModule.Column extends Pettanr.View
  tagName: 'div'
  className: 'columns'
  
  initialize: (options) ->
    @profiler = options.profiler
    @profiler_manifest = @profiler.profiler_manifest
    @columns = {}
    _.each @profiler_manifest.columns, (column, name) =>
      @columns[name] = @factory(@profiler, column)
  
  render: () ->
    this.$el.html('')
    _.each @sorted_columns(), (column) =>
      this.$el.append(column.render().el)
    this
  
  types: () ->
    {
      default: Locmare.ProfilerModule.ColumnModule.Default, 
      date: Locmare.ProfilerModule.ColumnModule.Date, 
      source: Locmare.ProfilerModule.ColumnModule.Source, 
      extend: Locmare.ProfilerModule.ColumnModule.Extend, 
      json: Locmare.ProfilerModule.ColumnModule.Json
    }
  
  factory: (profiler, my_manifest) ->
    type = my_manifest.type
    console.log("undefined type for local view filers > #{profiler.item_name} > edit\n") if not type
    my_class = @types()[type]
    console.log("undefined class for local view filers > #{profiler.item_name} > edit > #{type}\n") if not my_class
    new my_class({profiler: profiler,  column_manifest: my_manifest})
  
  sorted_columns: () ->
    _.map @profiler_manifest.column_names, (column_name) =>
      @columns[column_name]
  
class Locmare.ProfilerModule.ColumnModule

