class Pettanr.SystemPicture extends Peta.SystemResource
  
  @singular: () ->
    'SystemPicture'
  
  @plural: () ->
    'SystemPictures'
  
  defaults: {
    id: null
  } 
  
  filename: () ->
    @get('id') + '.' + @get('ext')
  
  mime_type: () ->
    'image/' + @get('ext')
  
  r_url: () ->
    '/system_pictures/' + @filename()
  
  opt_img_tag: () ->
    {src: @r_url(), width: @get('width'), height: @get('height')}
  
  tmb_opt_img_tag: () ->
    new Pettanr.Image.SymbolPicture({
      attr: {
        src: @r_url()
      },
      picture: this
    })
  
  symbol_option: (context, options) ->
    @retrieve(this, {
      success: (symbol_item) => 
        options.success.call(context, symbol_item.to_symbol())
    })
  
  picture_file: () ->
    new Pettanr.PictureFile(this)
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
  
