class WritingFormat < Peta::Template
  load_manifest
  has_many :speeches
  belongs_to :system_picture
  
  validates :name, :presence => true, :uniqueness => true, :length => {:maximum => 50}
  validates :module_name, :presence => true, :length => {:maximum => 50}
  validates :caption, :presence => true, :length => {:maximum => 30}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
  validates :system_picture_id, :presence => true, :numericality => true, :existence => {:both => false}
  validates :settings, :presence => true
  
  def supply_default
  end
  
  def overwrite
    self.t = WritingFormat.count.to_i if self.new_record?
  end
  
  def symbol_option
    self.system_picture.tmb_opt_img_tag
  end
  
  def self.list_order
    'writing_formats.t asc'
  end
  
#engine vw
def self.list
  self.enable_list
end

  def self.enable_list include_available = false
    r = WritingFormat.find(:all)
    unless include_available
      r.delete_if {|wf|
        wf.enable? == false
      }
    end
    r
  end
  
  def self.show_opt
    {}
  end
  
  def self.show_json_opt
    {}
  end
  
  def self.store name, attr
    r = WritingFormat.replace_system_picture(attr || {})
    attr["settings"] = r["settings"] ? r["settings"].to_json : nil
    r = WritingFormat.modify_object name, attr
    r.overwrite
    r.save
    r
  end
  
  def parsed_settings
    @parsed_settings ||= JSON.parse(self.settings)
  end
  
  # get template model   ex) PettanrSimpleFormat::Renderer
  # render method written in template model
  #def extend_model
  #  self.template_module.const_get 'Renderer'
  #end
  
  def self.import filename
    WritingFormat.import_file(filename) {|name, attr| WritingFormat.store(name, attr)}
  end
  
  def self.disp_import_error r
    if r == false
      puts "json file error. file does not exist or broken"
    else
      unless r.empty?
        r.each do |sbt|
          put sbt.errors.full_messages
        end
      end
    end
  end
end
