ManifestBase.require_modules "local_manifest/bucket/", 
  %w|member form_field_name|

module LocalManifest
  class Bucket < ManifestBase::Base
    include BucketModule
    
    attr :members, :form_field_names
    
    def set_default
      super
      @json['members'] ||= {}
      @json['form_field_names'] ||= {}
    end
    
    def init
      super
      @members = ManifestBase.load_name_values self, @json, 'members', Member
      @form_field_names = ManifestBase.load_names self, @json, 'form_field_names', FormFieldName
    end
    
    def has_member?
      @members.any?
    end
    
    def item_name
      @name
    end
    
  end
end

