module LocalManifest
  module FilerModule
    module CaptionModule
      module DefaultModule
        module LinkModule
          class BaseLink < ManifestBase::TypeArgs
            
            def set_default
              super
            end
            
            def init
              super
            end
            
            def filer
              @parent.filer
            end
            
          end
          
          class ActionLink < BaseLink
            attr :action_name
            
            def set_default
              super
              @args['action_name'] ||= 'show'
            end
            
            def init
              super
              @action_name = @args['action_name']
            end
            
          end
          
          class NoneLink < BaseLink
            
            def set_default
              super
            end
            
            def init
              super
            end
            
          end
          
          class UrlColumnLink < BaseLink
            attr :column_name
            
            def set_default
              super
              @args['column_name'] ||= 'url'
            end
            
            def init
              super
              @column_name = @args['column_name']
            end
            
          end
          
        end
      end
    end
  end
end
