require 'picture_io'
class PictureIO
  class LocalPicture
    def initialize base_dir = Rails.root + 'public/images/'
      @base = base_dir
    end
    
    def base
      @base
    end
    
    def base=(b)
      @base = b
    end
    
    def dir(subdir = nil)
      sd = if subdir.to_s.empty?
        self.base
      else
        self.base + (subdir.to_s + '/')
      end
      sd
    end
    
    def mkdir subdir = nil
      Dir.mkdir(base) unless File.exist?(base)
      return if subdir.to_s.empty?
      Dir.mkdir(dir(subdir)) unless File.exist?(dir(subdir))
    end
    
    def exist?(filename, subdir = nil)
      res = true
      begin
        res = File.exist?(dir(subdir) + filename)
      rescue
        raise PictureIO::Error
      end
      res
    end
    
    def put(bindata, filename, subdir = nil)
      res = true
      begin
        mkdir subdir
        File.open(dir(subdir) + filename, 'wb') do |f|
          f.write bindata
        end
      rescue
        raise PictureIO::Error
      end
      res
    end
    
    def get(filename, subdir = nil)
      bindata = ''
      begin
        File.open(dir(subdir) + filename, 'rb') do |f|
          bindata += f.read
        end
      rescue
        raise PictureIO::Error
      end
      bindata
    end
    
    def delete(filename, subdir = nil)
      res = true
      begin
        File.delete(dir(subdir) + filename)
      rescue
        raise PictureIO::Error
      end
      res
    end
    
  end
end
